@echo off
CHCP 65001
color 74

echo ".........................................................................................."
echo "Check BioStar2 Install Path"
echo ".........................................................................................."
set installPath=""
for /f "delims=" %%a in ('reg query HKEY_LOCAL_MACHINE\SOFTWARE\Suprema\Biostar2 /f "InstallLocation" /s 2^>nul ^| find /I "InstallLocation"') do set "installPath=%%a"
set "installPath=%installPath:InstallLocation    REG_SZ=%"
set "installPath=%installPath:~8%"
echo %installPath%

echo ".........................................................................................."
echo "Check Usb Agent Install Path"
echo ".........................................................................................."
set usbInstallPath = ""
for /f "delims=" %%a in ('reg query HKEY_CLASSES_ROOT\Installer\Products\8A9E628BA04A0644F883BE9A72EA1537\SourceList\Net /s 2^>nul ^| find /I "REG_EXPAND_SZ"') do set "usbInstallPath=%%a"
set "usbInstallPath=%usbInstallPath:1    REG_EXPAND_SZ=%"
set "usbInstallPath=%usbInstallPath:~8%"
echo %usbInstallPath%

echo ".........................................................................................."
echo "Stop all biostar 2 services"
echo ".........................................................................................."

net stop "BioStar 2 Web Server(x64)"
timeout /t 5
net stop "BioStar 2 Launcher(x64)"
timeout /t 2
net stop "BioStar 2 TA Web Server(x64)"
timeout /t 2
net stop "BioStar 2 Video Web Server(x64)"
timeout /t 2
net stop "BioStar 2 Report"

:: BatchGotAdmin
:-------------------------------------
REM  --> Check for permissions
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"

REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges...
    goto UACPrompt
) else ( goto gotAdmin )

:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params = %*:"=""
    echo UAC.ShellExecute "cmd.exe", "/c %~s0 %params%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    del "%temp%\getadmin.vbs"
    exit /B

:gotAdmin
    pushd "%CD%"
    CD /D "%~dp0"
:--------------------------------------

set BIOSTAR_HOME=%installPath%
set PATCH_HOME=%cd%
set JRE_PATH= %installPath%\jre\
set USB_AGENT=%usbInstallPath%


echo ".........................................................................................."
echo "move to biostar 2 home directory"
echo ".........................................................................................."
cd /D "%BIOSTAR_HOME%"
echo %cd%
set BIOSTAR_HOME=%cd%


echo "BIOSTAR_HOME_PATH:"%BIOSTAR_HOME%
echo "PATH_PATH:"%PATCH_HOME%
echo "JRE_PATH:"%JRE_PATH%

if not exist "%PATCH_HOME%\biostar-cert.exe" (
echo ".........................................................................................."
echo "fail to update biostar2, no biostar-cert.exe file."
echo ".........................................................................................."
pause
EXIT
)

if not exist "%PATCH_HOME%\jre\" (
echo ".........................................................................................."
echo "fail to update biostar2, no jre folder."
echo ".........................................................................................."
pause
EXIT
)

if not exist "%BIOSTAR_HOME%\jre\" (
echo ".........................................................................................."
echo "copy jre&patches"
echo ".........................................................................................."
xcopy "%PATCH_HOME%\biostar-cert.exe" "%BIOSTAR_HOME%" /K /D /H /Y
xcopy "%PATCH_HOME%\jre\" "%BIOSTAR_HOME%\jre\*" /S /E /K /D /H /Y
) else (

echo ".........................................................................................."
echo "copy patches"
echo ".........................................................................................."
xcopy "%PATCH_HOME%\biostar-cert.exe" "%BIOSTAR_HOME%" /K /D /H /Y
)


echo ".........................................................................................."
echo "backup certs"
echo ".........................................................................................."

move "%BIOSTAR_HOME%\nginx\conf\biostar_cert.crt" "%BIOSTAR_HOME%\nginx\conf\biostar_cert_backup.crt"
move "%BIOSTAR_HOME%\nginx\conf\biostar_cert.key" "%BIOSTAR_HOME%\nginx\conf\biostar_cert_backup.key"
move "%BIOSTAR_HOME%\nginx\conf\biostar_cert.p12" "%BIOSTAR_HOME%\nginx\conf\biostar_cert_backup.p12"
move "%BIOSTAR_HOME%\nginx\conf\keystore.jks" "%BIOSTAR_HOME%\nginx\conf\keystore_backup.jks"

echo ".........................................................................................."
echo "make cgi certs"
echo ".........................................................................................."

"%BIOSTAR_HOME%\biostar-cert.exe"

if not exist "%BIOSTAR_HOME%\nginx\conf\biostar_cert.crt" (
echo ".........................................................................................."
echo "fail to make biostar_cert.crt"
echo ".........................................................................................."
)

if not exist "%BIOSTAR_HOME%\nginx\conf\biostar_cert.key" (
echo ".........................................................................................."
echo "fail to make biostar_cert.key"
echo ".........................................................................................."
)

if not exist "%BIOSTAR_HOME%\nginx\conf\biostar_cert.p12" (
echo ".........................................................................................."
echo "fail to make biostar_cert.p12"
echo ".........................................................................................."
)

echo ".........................................................................................."
echo "make jks(java) certs"
echo "path:"%cd%
echo ".........................................................................................."

jre\bin\java.exe -cp "%BIOSTAR_HOME%\util";"%BIOSTAR_HOME%\util\lib\google-collect-1.0.jar";"%BIOSTAR_HOME%\util\lib\gson-2.8.2.jar" BioStarSetup "%BIOSTAR_HOME%"

if not exist "%BIOSTAR_HOME%\nginx\conf\keystore.jks" (
echo ".........................................................................................."
echo "fail to make keystore.jks"
echo ".........................................................................................."
)
echo ".........................................................................................."
echo "check usb agent..."
echo ".........................................................................................."

if exist %USB_AGENT% (
echo "backup & copy new certs"

echo ".........................................................................................."
echo "move to usb agent directory"
echo ".........................................................................................."
cd /D "%USB_AGENT%"
set USB_AGENT=%cd%
echo %USB_AGENT%

move "%USB_AGENT%\config\localhost_cert.crt" "%USB_AGENT%\config\localhost_cert_backup.crt"
move "%USB_AGENT%\config\localhost_cert.key" "%USB_AGENT%\config\localhost_cert_backup.key"

echo %USB_AGENT%
echo %PATCH_HOME%
xcopy "%PATCH_HOME%\usb-agent\config\localhost_cert.crt" "%USB_AGENT%\config\*" /K /D /H /Y
xcopy "%PATCH_HOME%\usb-agent\config\localhost_cert.key" "%USB_AGENT%\config\*" /K /D /H /Y
)

cd /D "%PATCH_HOME%"
echo ".........................................................................................."
echo "Start all biostar 2 services"
echo ".........................................................................................."

net start "BioStar 2 Web Server(x64)"
timeout /t 5
net start "BioStar 2 Launcher(x64)"
timeout /t 2
net start "BioStar 2 TA Web Server(x64)"
timeout /t 2
net start "BioStar 2 Video Web Server(x64)"
timeout /t 2
net start "BioStar 2 Report"
timeout /t 5

echo ".........................................................................................."
echo "Done...Please restart your PC to apply changes."
echo ".........................................................................................."

pause